{******************************************************************************}
{   unit InspectorGrid                                                        }
{                                                                              }
{ Descendant de TStringGrid,  deux colones uniques avec pour chaque ligne une }
{ collection d'objets (TCombobox, TButton et TEdit). Simule ( peu prs) le    }
{ comportement de la grille de l'inspecteur d'objet de Delphi. Je l'utilise    }
{ pour un moniteur d'interfaces utilisateurs semi-dynamiques.                  }
{                                                                              }
{ La majorit des routines sont issues de l'unit DBGrids pour le composant    }
{ TDBGrid, c'est la raison pour laquelle ce composant est gratuit, n'ayant     }
{ travaill que quelques heures et donc apport peu de valeur ajout. Des      }
{ composants similaires existent sur le net et pratiquement tous en shareware, }
{ souvent sans les sources. Dans la mojorit des cas il s'agit d'un travail    }
{ semblable au mien, quand ce n'est pas rcuprer des freewares pour les       }
{ transformer en shareware en supprimant les en-ttes et les commentaires      }
{ d'origines (je l'ai constat!).                                              }
{                                                                              }
{  COPYRIGHT / GARANTIE                                                        }
{                                                                              }
{ Ce composant est un gratuiciel et donc libre de droits. Il est fourni        }
{ TEL QUEL, sans aucune garantie expresse ou tacite, pour quelque raison       }
{ que ce soit, y compris d'ventuels dommages causs par l'utilisation de ce   }
{ composant, les dommages pour pertes de profits, cessation d'activites        }
{ commerciales ou autre.                                                       }
{ Vous pouvez utiliser ce composant comme bon vous semble, except pour une    }
{ utilisation commerciale, c'est  dire ne pas utiliser tout ou  partie de ce  }
{ composant dans un projet commercial (Dans ce cas le paiement d'une modeste   }
{ licence vous sera demand - contactez moi pour les prcisions).              }
{ Vous ne pouvez pas prtendre avoir crit ce composant et vous n'tes pas     }
{ autoris  supprimer l'en-tte du fichier source (question d'thique).       }
{ Si vous n'tes pas en accord avec ce qui prcde, ne l'utilisez pas.         }
{
{ Donc, si vous modifiez ou amliorez ce composant, laissez intacte l'en-tte  }
{ de ce fichier et ajoutez vos commentaires  la fin de cet l'en-tte.         }
{ Tous commentaires et/ou suggestions, rapport de bug, seront apprcis.       }
{                                                                              }
{ Auteur : Jean-Michel BOUCTON                                                 }
{ email : jmbo@softhome.net                                                    }
{                                                                              }
{ Merci  Magnus Lidman (email: d95mange@dtek.chalmers.se) et son composant    }
{ TImpStringGrid pour m'avoir inspir.                                         }
{------------------------------------------------------------------------------}
{    Exemple d'utilisation                                                     }
{  Evidemment les diffrentes variables mentionnes (list, i, etc.) doivent    }
{  avoir t pralablement dclares.                                          }
{                                                                              }
{  with InspectorGrid do                                                       }
{  begin                                                                       }
{    Rowcount := 10;                                                           }
{    Lines.Items[0].ButtonStyle := lbsPicklist;                                }
{    Lines.Items[1].ButtonStyle := lbsEllipsis;                                }
{    Lines.Items[4].ButtonStyle := lbsPicklist;                                }
{    Lines.Items[9].ButtonStyle := lbsPicklist;                                }
{    Lines.Items[0].title.caption := 'CbsPicklist';                            }
{    Lines.Items[1].title.caption := 'CbsEllipsis';                            }
{    Lines.Items[2].title.caption := 'Rightjustify';                           }
{    Lines.Items[3].title.caption := 'CbsNone';                                }
{    Lines.Items[4].title.caption := 'CbsPicklist';                            }
{    for i := 5 to 9 do                                                        }
{      Lines.Items[i].title.caption := 'CbsNone' + IntToStr(i);                }
{                                                                              }
{    Lines.Items[9].title.caption := 'CbsPicklist';                            }
{    list := tstringlist.create;                                               }
{    try                                                                       }
{      list.add('true');                                                       }
{      list.add('false');                                                      }
{      Lines.Items[0].Picklist := list;                                        }
{      List.Clear;                                                             }
{      list.add('clBtnFace');                                                  }
{      list.add('clBtnShadow');                                                }
{      list.add('clWhite');                                                    }
{      list.add('clBlack');                                                    }
{      list.add('clRed');                                                      }
{      list.add('clBlue');                                                     }
{      Lines.Items[4].Picklist := list;                                        }
{    finally                                                                   }
{      List.Free;                                                              }
{    end;                                                                      }
{  end;                                                                        }
{------------------------------------------------------------------------------}
{ Auteur : Jean-Michel BOUCTON                                                 }
{ Version : 1.0.0                                                              }
{ Cration : 05/09/1998                                                        }
{                                                                              }
{------------------------------------------------------------------------------}
{ Auteur : Jean-Michel BOUCTON                                                 }
{ Version : 1.1.0                                                              }
{ Date : 31/12/1998                                                            }
{                                                                              }
{ Ajout de la proprit Data dans TEnhLine.                                    }
{------------------------------------------------------------------------------}
{ Auteur :                                                                     }
{ Version :                                                                    }
{ Date :                                                                       }
{                                                                              }
{******************************************************************************}
unit InspectorGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Stdctrls, Extctrls;

type
  TEnhgridCellEvent = procedure (Sender: TObject; Col, Row: Longint) of object;
  TEnhgriddropdownEvent = procedure (Sender: TObject; Col, Row: Longint;
                                    var Picklist:Tstrings) of object;
   TEnhLineValue = (cvColor, cvWidth, cvFont, cvAlignment, cvReadOnly, cvTitleColor,
    cvTitleCaption, cvTitleAlignment, cvTitleFont, cvImeMode, cvImeName);
  TEnhLineValues = set of TEnhLineValue;

{ TEnhLine defines internal storage for Line attributes.  Values assigned
  to properties are stored in this object, the grid- or field-based default
  sources are not modified.  Values read from properties are the previously
  assigned value, if any, or the grid- or field-based default values if
  nothing has been assigned to that property. This class also publishes the
  Line attribute properties for persistent storage.  }
  TEnhGridLinesState = (csDefault, csCustomized);
  TEnhLine = class;
  TEnhLineClass = class of TEnhLine;

  TInspectorGrid = class;

  TEnhLineTitle = class(TPersistent)
  private
    FLine: TEnhLine;
    FCaption: string;
    FFont: TFont;
    FColor: TColor;
    FAlignment: TAlignment;
    procedure FontChanged(Sender: TObject);
    function GetAlignment: TAlignment;
    function GetColor: TColor;
    function GetCaption: string;
    function GetFont: TFont;
    function IsAlignmentStored: Boolean;
    function IsColorStored: Boolean;
    function IsFontStored: Boolean;
    function IsCaptionStored: Boolean;
    procedure SetAlignment(Value: TAlignment);
    procedure SetColor(Value: TColor);
    procedure SetFont(Value: TFont);
    procedure SetCaption(const Value: string); virtual;
  protected
    procedure RefreshDefaultFont;
  public
    constructor Create(Line: TEnhLine);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function DefaultAlignment: TAlignment;
    function DefaultColor: TColor;
    function DefaultFont: TFont;
    function DefaultCaption: string;
    procedure RestoreDefaults; virtual;
  published
    property Alignment: TAlignment read GetAlignment write SetAlignment
      stored IsAlignmentStored;
    property Caption: string read GetCaption write SetCaption stored IsCaptionStored;
    property Color: TColor read GetColor write SetColor stored IsColorStored;
    property Font: TFont read GetFont write SetFont stored IsFontStored;
  end;

  TEditStyle = (esSimple, esEllipsis, esPickList, esDataList);
  TPopupListbox = class;

{ TEnhGridInplaceEdit }

{ TEnhGridInplaceEdit adds support for a button on the in-place editor,
  which can be used to drop down a table-based lookup list, a stringlist-based
  pick list, or (if button style is esEllipsis) fire the grid event
  OnEditButtonClick.  }

  TEnhGridInplaceEdit = class(TInplaceEdit)
  private
    FButtonWidth: Integer;
    FPickList: TPopupListbox;
    FActiveList: TWinControl;
    FEditStyle: TEditStyle;
    FListVisible: Boolean;
    FTracking: Boolean;
    FPressed: Boolean;
    procedure ListMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SetEditStyle(Value: TEditStyle);
    procedure StopTracking;
    procedure TrackButton(X,Y: Integer);
    procedure CMCancelMode(var Message: TCMCancelMode); message CM_CancelMode;
    procedure WMCancelMode(var Message: TMessage); message WM_CancelMode;
    procedure WMKillFocus(var Message: TMessage); message WM_KillFocus;
    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message wm_LButtonDblClk;
    procedure WMPaint(var Message: TWMPaint); message wm_Paint;
    procedure WMSetCursor(var Message: TWMSetCursor); message WM_SetCursor;
  protected
    procedure BoundsChanged; override;
    procedure CloseUp(Accept: Boolean);
    procedure DoDropDownKeys(var Key: Word; Shift: TShiftState);
    procedure DropDown;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure PaintWindow(DC: HDC); override;
    procedure UpdateContents; override;
    procedure WndProc(var Message: TMessage); override;
    property  EditStyle: TEditStyle read FEditStyle write SetEditStyle;
    property  ActiveList: TWinControl read FActiveList write FActiveList;
    property  PickList: TPopupListbox read FPickList;
  public
    constructor Create(Owner: TComponent); override;
  end;

{ TPopupListbox }

  TPopupListbox = class(TCustomListbox)
  private
    FSearchText: String;
    FSearchTickCount: Longint;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure KeyPress(var Key: Char); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  end;

  TEnhLineButtonStyle = (lbsPicklist, lbsEllipsis, lbsNone);

  TEnhLine = class(TCollectionItem)
  private
    FColor: TColor;
    FWidth: Integer;
    FTitle: TEnhLineTitle;
    FFont: TFont;
    FImeMode: TImeMode;
    FImeName: TImeName;
    FPickList: TStrings;
    FDropDownRows: Cardinal;
    FButtonStyle: TEnhLineButtonStyle;
    FAlignment: TAlignment;
    FReadonly: Boolean;
    FAssignedValues: TEnhLineValues;
    FData: Pointer;
    procedure FontChanged(Sender: TObject);
    function  GetAlignment: TAlignment;
    function  GetColor: TColor;
    function  GetFont: TFont;
    function  GetImeMode: TImeMode;
    function  GetImeName: TImeName;
    function  GetPickList: TStrings;
    function  GetReadOnly: Boolean;
    function  GetWidth: Integer;
    function  IsAlignmentStored: Boolean;
    function  IsColorStored: Boolean;
    function  IsFontStored: Boolean;
    function  IsImeModeStored: Boolean;
    function  IsImeNameStored: Boolean;
    function  IsReadOnlyStored: Boolean;
    function  IsWidthStored: Boolean;
    procedure SetAlignment(Value: TAlignment); virtual;
    procedure SetButtonStyle(Value: TEnhLineButtonStyle);
    procedure SetColor(Value: TColor);
    procedure SetFont(Value: TFont);
    procedure SetImeMode(Value: TImeMode); virtual;
    procedure SetImeName(Value: TImeName); virtual;
    procedure SetPickList(Value: TStrings);
    procedure SetReadOnly(Value: Boolean); virtual;
    procedure SetTitle(Value: TEnhLineTitle);
    procedure SetWidth(Value: Integer); virtual;
    procedure SetData(Value: Pointer);
  protected
    function  CreateTitle: TEnhLineTitle; virtual;
    function  GetGrid: TInspectorGrid;
    function GetDisplayName: string; override;
    procedure RefreshDefaultFont;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function  DefaultAlignment: TAlignment;
    function  DefaultColor: TColor;
    function  DefaultFont: TFont;
    function  DefaultImeMode: TImeMode;
    function  DefaultImeName: TImeName;
    function  DefaultReadOnly: Boolean;
    function  DefaultWidth: Integer;
    procedure RestoreDefaults; virtual;
    property  Grid: TInspectorGrid read GetGrid;
    property  AssignedValues: TEnhLineValues read FAssignedValues;
    property Data: Pointer read FData write SetData;
  published
    property  Alignment: TAlignment read GetAlignment write SetAlignment
      stored IsAlignmentStored;
    property  ButtonStyle: TEnhLineButtonStyle read FButtonStyle write SetButtonStyle
      default lbsNone;
    property  Color: TColor read GetColor write SetColor stored IsColorStored;
    property  DropDownRows: Cardinal read FDropDownRows write FDropDownRows default 7;
    property  Font: TFont read GetFont write SetFont stored IsFontStored;
    property  ImeMode: TImeMode read GetImeMode write SetImeMode stored IsImeModeStored;
    property  ImeName: TImeName read GetImeName write SetImeName stored IsImeNameStored;
    property  PickList: TStrings read GetPickList write SetPickList;
    property  ReadOnly: Boolean read GetReadOnly write SetReadOnly
      stored IsReadOnlyStored;
    property  Title: TEnhLineTitle read FTitle write SetTitle;
    property  Width: Integer read GetWidth write SetWidth stored IsWidthStored;
  end;

  TEnhGridLines = class(TCollection)
  private
    FGrid: TInspectorGrid;
    function GetCount:Integer;
    function GetState: TEnhGridLinesState;
    function GeTEnhLine(Index: Integer): TEnhLine;
    procedure SeTEnhLine(Index: Integer; Value: TEnhLine);
    procedure SetState(NewState: TEnhGridLinesState);
  protected
    function GetOwner: TPersistent; override;
    procedure Update(Item: TCollectionItem); override;
  public
    constructor Create(Grid: TInspectorGrid; LineClass: TEnhLineClass);
    function  Add: TEnhLine;
    procedure LoadFromFile(const Filename: string);
    procedure LoadFromStream(S: TStream);
    procedure RestoreDefaults;
    procedure RebuildLines;
    procedure SaveToFile(const Filename: string);
    procedure SaveToStream(S: TStream);
    property State: TEnhGridLinesState read GetState write SetState;
    property Grid: TInspectorGrid read FGrid;
    property Items[Index: Integer]: TEnhLine read GeTEnhLine write SeTEnhLine; default;
    property Count: integer read GetCount;
  end;

  TMovedSplitEvent = procedure (Sender: TObject; FromPos, ToPos: Longint) of object;

  TGridSplit = class(TPanel)
  private
    FLineDC: HDC;
    FDownPos: TPoint;
    FSplit: Integer;
    FMinSize: NaturalNumber;
    FMaxSize: Integer;
    FControl: TControl;
    FNewSize: Integer;
    FActiveControl: TWinControl;
    FLineVisible: Boolean;
    FOnMoved: TMovedSplitEvent;
    procedure AllocateLineDC;
    procedure DrawLine;
    procedure ReleaseLineDC;
    procedure UpdateSize(X, Y: Integer);
  protected
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure StopSizing;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property OnMoved: TMovedSplitEvent read FOnMoved write FOnMoved;
  end;

  TEnhGridOption = (egoFixedVertLine, egoFixedHorzLine, egoHorzLine,
                    egoDrawFocusSelected, egoEditing, egoTabs,
                    egoAlwaysShowEditor, egoThumbTracking);
  TEnhGridOptions = set of TEnhGridOption;

  TInspectorGrid = class(TStringGrid)
  private
    FOnNewRow: TnotifyEvent;
    FOnElippsisclicked: TEnhgridCellEvent;
    FOnPicklistDropdown: TEnhgridDropDownEvent;
    FDummy: Byte;
    FOptions: TEnhGridOptions;
    FSelectedTitleBold: boolean;
    function GetOnSplitMoved: TMovedSplitEvent;
    procedure SetOnSplitMoved(value: TMovedSplitEvent);
    procedure SetOptions(value: TEnhGridOptions);
    function IsActiveControl: Boolean;
    function GetColCount: Integer;
    function GetRowCount: Integer;
    procedure SetRowCount(ARow: LongInt);
    function GetDefaultColWidth: integer;
    procedure SetDefaultColWidth(Value: integer);
    procedure Editbuttonclick;
    procedure WMSize(var Msg: TWMSize); message WM_SIZE;
    procedure UpdateEditCellsSize;
  protected
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState); override;
    function  CreateEditor: TInplaceEdit; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure Paint; override;
    procedure SetSelectedTitleBold(Value: boolean);
    procedure WMVScroll(var Msg: TWMVScroll); message WM_VSCROLL;
  public
    Lines: TEnhGridLines;
    GridSplit1: TGridSplit;
    constructor Create(Owner: TComponent); override;
    destructor Destroy; override;
    procedure ResizeColums;
    procedure Clear;
    procedure HideEditor;
    procedure ShowEditor;
  published
    property DefaultColWidth: Integer read GetDefaultColWidth write SetDefaultColWidth default 90;
    property OnNewRow : TNotifyEvent read FOnNewRow write FOnNewRow;
    property OnElippsisclicked : TEnhGridCellEvent read fOnElippsisclicked write fOnElippsisclicked;
    property OnPicklistDropdown : TEnhGridDropdownEvent read fOnPicklistDropdown write fOnPicklistDropdown;
    property ColCount: Longint read GetColCount;
    property RowCount: Longint read GetRowCount write SetRowCount default 4;
    property GridHeight;
    property OnSplitMoved: TMovedSplitEvent read GetOnSplitMoved write SetOnSplitMoved;
    property Options: TEnhGridOptions read FOptions write SetOptions
      default [egoHorzLine, egoEditing, egoAlwaysShowEditor];
    property FixedRows: Byte read FDummy;
    property SelectedTitleBold: boolean read FSelectedTitleBold write SetSelectedTitleBold default True;
  end;

const
  LineTitleValues = [cvTitleColor..cvTitleFont];
  cm_DeferLayout = WM_USER + 100;

implementation
var
  DrawBitmap: TBitmap;

function Max(X, Y: Integer): Integer;
begin
  Result := Y;
  if X > Y then Result := X;
end;

procedure KillMessage(Wnd: HWnd; Msg: Integer);
// Delete the requested message from the queue, but throw back
// any WM_QUIT msgs that PeekMessage may also return
var
  M: TMsg;
begin
  M.Message := 0;
  if PeekMessage(M, Wnd, Msg, Msg, pm_Remove) and (M.Message = WM_QUIT) then
    PostQuitMessage(M.wparam);
end;

procedure WriteText(ACanvas: TCanvas; ARect: TRect; DX, DY: Integer;
  const Text: string; Alignment: TAlignment);
const
  AlignFlags : array [TAlignment] of Integer =
    ( DT_LEFT or DT_WORDBREAK or DT_EXPANDTABS or DT_NOPREFIX,
      DT_RIGHT or DT_WORDBREAK or DT_EXPANDTABS or DT_NOPREFIX,
      DT_CENTER or DT_WORDBREAK or DT_EXPANDTABS or DT_NOPREFIX );
var
  B, R: TRect;
  I, Left: Integer;
begin
  I := ColorToRGB(ACanvas.Brush.Color);
  if GetNearestColor(ACanvas.Handle, I) = I then
  begin                       { Use ExtTextOut for solid colors }
    case Alignment of
      taLeftJustify:
        Left := ARect.Left + DX;
      taRightJustify:
        Left := ARect.Right - ACanvas.TextWidth(Text) - 3;
    else { taCenter }
      Left := ARect.Left + (ARect.Right - ARect.Left) shr 1
        - (ACanvas.TextWidth(Text) shr 1);
    end;
    ExtTextOut(ACanvas.Handle, Left, ARect.Top + DY, ETO_OPAQUE or
      ETO_CLIPPED, @ARect, PChar(Text), Length(Text), nil);
  end
  else begin                  { Use FillRect and Drawtext for dithered colors }
    DrawBitmap.Canvas.Lock;
    try
      with DrawBitmap, ARect do { Use offscreen bitmap to eliminate flicker and }
      begin                     { brush origin tics in painting / scrolling.    }
        Width := Max(Width, Right - Left);
        Height := Max(Height, Bottom - Top);
        R := Rect(DX, DY, Right - Left - 1, Bottom - Top - 1);
        B := Rect(0, 0, Right - Left, Bottom - Top);
      end;
      with DrawBitmap.Canvas do
      begin
        Font := ACanvas.Font;
        Font.Color := ACanvas.Font.Color;
        Brush := ACanvas.Brush;
        Brush.Style := bsSolid;
        FillRect(B);
        SetBkMode(Handle, TRANSPARENT);
        DrawText(Handle, PChar(Text), Length(Text), R, AlignFlags[Alignment]);
      end;
      ACanvas.CopyRect(ARect, DrawBitmap.Canvas, B);
    finally
      DrawBitmap.Canvas.Unlock;
    end;
  end;
end;

{ TPopupListbox }

procedure TPopupListBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    Style := Style or WS_BORDER;
    ExStyle := WS_EX_TOOLWINDOW or WS_EX_TOPMOST;
    WindowClass.Style := CS_SAVEBITS;
  end;
end;

procedure TPopupListbox.CreateWnd;
begin
  inherited CreateWnd;
  Windows.SetParent(Handle, 0);
  CallWindowProc(DefWndProc, Handle, wm_SetFocus, 0, 0);
end;

procedure TPopupListbox.Keypress(var Key: Char);
var
  TickCount: Integer;
begin
  case Key of
    #8, #27: FSearchText := '';
    #32..#255:
    begin
      TickCount := GetTickCount;
      if TickCount - FSearchTickCount > 2000 then
        FSearchText := '';
      FSearchTickCount := TickCount;
      if Length(FSearchText) < 32 then
        FSearchText := FSearchText + Key;
      SendMessage(Handle, LB_SelectString, WORD(-1), Longint(PChar(FSearchText)));
      Key := #0;
    end;
  end;
  inherited Keypress(Key);
end;

procedure TPopupListbox.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseUp(Button, Shift, X, Y);
  TEnhGridInplaceEdit(Owner).CloseUp( (X >= 0) and (Y >= 0) and
                                      (X < Width) and (Y < Height) );
end;

{ TEnhLineTitle }

constructor TEnhLineTitle.Create(Line: TEnhLine);
begin
  inherited Create;
  FLine := Line;
  FFont := TFont.Create;
  FFont.Assign(DefaultFont);
  if FLine.FReadonly then
    FFont.Color := clBtnShadow
  else
    FFont.Color := clBlack;
  FFont.OnChange := FontChanged;
end;

destructor TEnhLineTitle.Destroy;
begin
  FFont.Free;
  inherited Destroy;
end;

procedure TEnhLineTitle.Assign(Source: TPersistent);
begin
  if Source is TEnhLineTitle then
  begin
    if cvTitleAlignment in TEnhLineTitle(Source).FLine.FAssignedValues then
      Alignment := TEnhLineTitle(Source).Alignment;
    if cvTitleColor in TEnhLineTitle(Source).FLine.FAssignedValues then
      Color := TEnhLineTitle(Source).Color;
    if cvTitleCaption in TEnhLineTitle(Source).FLine.FAssignedValues then
      Caption := TEnhLineTitle(Source).Caption;
    if cvTitleFont in TEnhLineTitle(Source).FLine.FAssignedValues then
      Font := TEnhLineTitle(Source).Font;
  end else
    inherited Assign(Source);
end;

function TEnhLineTitle.DefaultAlignment: TAlignment;
begin
  Result := taLeftJustify;
end;

function TEnhLineTitle.DefaultColor: TColor;
var
  Grid: TInspectorGrid;
begin
  Grid := FLine.GetGrid;
  if Assigned(Grid) then
    Result := Grid.FixedColor
  else
    Result := clBtnFace;
end;

function TEnhLineTitle.DefaultFont: TFont;
begin
  Result := FLine.Font;
end;

function TEnhLineTitle.DefaultCaption: string;
begin
  Result := '';
end;

procedure TEnhLineTitle.FontChanged(Sender: TObject);
begin
  Include(FLine.FAssignedValues, cvTitleFont);
  FLine.Changed(True);
end;

function TEnhLineTitle.GetAlignment: TAlignment;
begin
  if cvTitleAlignment in FLine.FAssignedValues then
    Result := FAlignment
  else
    Result := DefaultAlignment;
end;

function TEnhLineTitle.GetColor: TColor;
begin
  if cvTitleColor in FLine.FAssignedValues then
    Result := FColor
  else
    Result := DefaultColor;
end;

function TEnhLineTitle.GetCaption: string;
begin
  if cvTitleCaption in FLine.FAssignedValues then
    Result := FCaption
  else
    Result := DefaultCaption;
end;

function TEnhLineTitle.GetFont: TFont;
var
  Save: TNotifyEvent;
  Def: TFont;
begin
  if not (cvTitleFont in FLine.FAssignedValues) then
  begin
    Def := DefaultFont;
    if (FFont.Handle <> Def.Handle) or (FFont.Color <> Def.Color) then
    begin
      Save := FFont.OnChange;
      FFont.OnChange := nil;
      FFont.Assign(DefaultFont);
      if FLine.FReadonly then
        FFont.Color := clBtnShadow
      else
        FFont.Color := clBlack;
      FFont.OnChange := Save;
    end;
  end;
  Result := FFont;
end;

function TEnhLineTitle.IsAlignmentStored: Boolean;
begin
  Result := (cvTitleAlignment in FLine.FAssignedValues) and
    (FAlignment <> DefaultAlignment);
end;

function TEnhLineTitle.IsColorStored: Boolean;
begin
  Result := (cvTitleColor in FLine.FAssignedValues) and
    (FColor <> DefaultColor);
end;

function TEnhLineTitle.IsFontStored: Boolean;
begin
  Result := (cvTitleFont in FLine.FAssignedValues);
end;

function TEnhLineTitle.IsCaptionStored: Boolean;
begin
  Result := (cvTitleCaption in FLine.FAssignedValues) and
    (FCaption <> DefaultCaption);
end;

procedure TEnhLineTitle.RefreshDefaultFont;
var
  Save: TNotifyEvent;
begin
  if (cvTitleFont in FLine.FAssignedValues) then Exit;
  Save := FFont.OnChange;
  FFont.OnChange := nil;
  try
    FFont.Assign(DefaultFont);
  finally
    FFont.OnChange := Save;
  end;
end;

procedure TEnhLineTitle.RestoreDefaults;
var
  FontAssigned: Boolean;
begin
  FontAssigned := cvTitleFont in FLine.FAssignedValues;
  FLine.FAssignedValues := FLine.FAssignedValues - LineTitleValues;
  FCaption := '';
  RefreshDefaultFont;
  { If font was assigned, changing it back to default may affect grid title
    height, and title height changes require layout and redraw of the grid. }
  FLine.Changed(FontAssigned);
end;

procedure TEnhLineTitle.SetAlignment(Value: TAlignment);
begin
  if (cvTitleAlignment in FLine.FAssignedValues) and (Value = FAlignment) then Exit;
  FAlignment := Value;
  Include(FLine.FAssignedValues, cvTitleAlignment);
  FLine.Changed(False);
end;

procedure TEnhLineTitle.SetColor(Value: TColor);
begin
  if (cvTitleColor in FLine.FAssignedValues) and (Value = FColor) then Exit;
  FColor := Value;
  Include(FLine.FAssignedValues, cvTitleColor);
  FLine.Changed(False);
end;

procedure TEnhLineTitle.SetFont(Value: TFont);
begin
  FFont.Assign(Value);
end;

procedure TEnhLineTitle.SetCaption(const Value: string);
begin
  if (cvTitleCaption in FLine.FAssignedValues) and (Value = FCaption) then Exit;
  FCaption := Value;
  Include(FLine.FAssignedValues, cvTitleCaption);
  FLine.Changed(False);
end;

{ TEnhGridInplaceEdit}

constructor TEnhGridInplaceEdit.Create(Owner: TComponent);
begin
  inherited Create(Owner);
  FButtonWidth := GetSystemMetrics(SM_CXVSCROLL);
  FEditStyle := esEllipsis;
end;

procedure TEnhGridInplaceEdit.BoundsChanged;
var
  R: TRect;
begin
  if Height > (Owner as TInspectorGrid).DefaultRowHeight then
   Height := (Owner as TInspectorGrid).DefaultRowHeight;
  SetRect(R, 2, 2, Width - 2, Height);
  if FEditStyle <> esSimple then Dec(R.Right, FButtonWidth);
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@R));
  SendMessage(Handle, EM_SCROLLCARET, 0, 0);
  if SysLocale.Fareast then
    SetImeCompositionWindow(Font, R.Left, R.Top);
end;

procedure TEnhGridInplaceEdit.CloseUp(Accept: Boolean);
var
  ListValue: Variant;
begin
  if FListVisible then
  begin
    if GetCapture <> 0 then
      SendMessage(GetCapture, WM_CANCELMODE, 0, 0);
    if FPickList.ItemIndex <> -1 then
      ListValue := FPickList.Items[FPicklist.ItemIndex];
    SetWindowPos(FActiveList.Handle, 0, 0, 0, 0, 0, SWP_NOZORDER or
                 SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE or SWP_HIDEWINDOW);
    FListVisible := False;
    Invalidate;
    if Accept then
      if (not VarIsNull(ListValue)) and EditCanModify then
        Text := ListValue;
  end;
end;

procedure TEnhGridInplaceEdit.DoDropDownKeys(var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_UP, VK_DOWN:
      if ssAlt in Shift then
      begin
        if FListVisible then CloseUp(True) else DropDown;
        Key := 0;
      end;
    VK_RETURN, VK_ESCAPE:
      if FListVisible and not (ssAlt in Shift) then
      begin
        CloseUp(Key = VK_RETURN);
        Key := 0;
      end;
  end;
end;

procedure TEnhGridInplaceEdit.DropDown;
var
  P: TPoint;
  I,J,Y: Integer;
  Line: TEnhLine;
  str : Tstrings;
begin
  if not FListVisible and Assigned(FActiveList) then
  begin
    FActiveList.Width := Width;
    with TInspectorGrid(Grid) do
    begin
      Line := Lines[Row];

      FPickList.Color := Color;
      FPickList.Font := Font;
      FPickList.Items := Line.Picklist;
      if assigned(TInspectorGrid(Grid).OnPickListDropDown) then
      begin
        str := Tstringlist.create;
        str.assign(fpicklist.items);
        TInspectorGrid(Grid).OnPickListDropDown(Self,
                                                TInspectorGrid(Grid).Col,
                                                TInspectorGrid(Grid).Row,
                                                str);
        fpicklist.items.Assign(str);
      end;
      if FPickList.Items.Count >= Line.DropDownRows then
        FPickList.Height := Line.DropDownRows * FPickList.ItemHeight + 4
      else
        FPickList.Height := FPickList.Items.Count * FPickList.ItemHeight + 4;
        FPickList.ItemIndex := -1;
      J := FPickList.ClientWidth;
      for I := 0 to FPickList.Items.Count - 1 do
      begin
        Y := FPickList.Canvas.TextWidth(FPickList.Items[I]);
        if Y > J then J := Y+10;
      end;
      FPickList.ClientWidth := J;
    end;
    P := Parent.ClientToScreen(Point(Left, Top));
    Y := P.Y + Height;
    if Y + FActiveList.Height > Screen.Height then Y := P.Y - FActiveList.Height;
    SetWindowPos(FActiveList.Handle, HWND_TOP, P.X, Y, 0, 0,
      SWP_NOSIZE or SWP_NOACTIVATE or SWP_SHOWWINDOW);
    FListVisible := True;
    Invalidate;
    Windows.SetFocus(Handle);
  end;
end;

type
  TWinControlCracker = class(TWinControl) end;

procedure TEnhGridInplaceEdit.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_RETURN) and (Shift = [ssCtrl]) then
  begin
    if (EditStyle = esEllipsis) then
    begin
      TInspectorGrid(Grid).EditButtonClick;
      Perform(EM_UNDO, 0, 0);
    end;
    KillMessage(Handle, WM_CHAR);
  end
  else if (Key = VK_ESCAPE) then
    Perform(EM_UNDO, 0, 0)
  else
    inherited KeyDown(Key, Shift);
end;

procedure TEnhGridInplaceEdit.ListMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    CloseUp(PtInRect(FActiveList.ClientRect, Point(X, Y)));
end;

procedure TEnhGridInplaceEdit.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  if (Button = mbLeft) and (FEditStyle <> esSimple) and
    PtInRect(Rect(Width - FButtonWidth, 0, Width, Height), Point(X,Y)) then
  begin
    if FListVisible then
      CloseUp(False)
    else
    begin
      with TInspectorGrid(Grid) do
        if Lines[Row].FReadonly then
          exit;
      MouseCapture := True;
      FTracking := True;
      TrackButton(X, Y);
      if Assigned(FActiveList) then DropDown;
    end;
  end;
  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TEnhGridInplaceEdit.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  ListPos: TPoint;
  MousePos: TSmallPoint;
begin
  if FTracking then
  begin
    TrackButton(X, Y);
    if FListVisible then
    begin
      ListPos := FActiveList.ScreenToClient(ClientToScreen(Point(X, Y)));
      if PtInRect(FActiveList.ClientRect, ListPos) then
      begin
        StopTracking;
        MousePos := PointToSmallPoint(ListPos);
        SendMessage(FActiveList.Handle, WM_LBUTTONDOWN, 0, Integer(MousePos));
        Exit;
      end;
    end;
  end;
  inherited MouseMove(Shift, X, Y);
end;

procedure TEnhGridInplaceEdit.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  WasPressed: Boolean;
begin
  WasPressed := FPressed;
  StopTracking;
  if (Button = mbLeft) and (FEditStyle = esEllipsis) and WasPressed then
    TInspectorGrid(Grid).EditButtonClick;
  inherited MouseUp(Button, Shift, X, Y);
end;

procedure TEnhGridInplaceEdit.PaintWindow(DC: HDC);
var
  R: TRect;
  Flags: Integer;
  HPbl, HOldP: HPen;
begin
    HPbl := CreatePen(PS_SOLID, 1, clBlack);
    HOldP := SelectObject(DC, HPbl);
  if FEditStyle <> esSimple then
  begin
    SetRect(R, Width - FButtonWidth, 1, Width, Height);
    Flags := 0;
    if FEditStyle in [esDataList, esPickList] then
    begin
      if FActiveList = nil then
        Flags := DFCS_INACTIVE
      else if FPressed then
        Flags := DFCS_FLAT or DFCS_PUSHED;
      DrawFrameControl(DC, R, DFC_SCROLL, Flags or DFCS_SCROLLCOMBOBOX);
    end
    else   { esEllipsis }
    begin
      if FPressed then
        Flags := BF_FLAT;
      DrawEdge(DC, R, EDGE_RAISED, BF_RECT or BF_MIDDLE or Flags);
      Flags := ((R.Right - R.Left) shr 1) + Ord(FPressed);

      PatBlt(DC, R.Left + Flags, R.Top + 10, 1, 1, BLACKNESS);
      PatBlt(DC, R.Left + Flags-3, R.Top + 10, 1, 1, BLACKNESS);
      PatBlt(DC, R.Left + Flags+3, R.Top + 10, 1, 1, BLACKNESS);

    end;
    SetRect(R, 0, 0, Width, Height);
    Windows.MoveToEx(DC, R.Left, R.Top, nil);
    Windows.LineTo(DC, R.Right, R.Top);
    SetRect(R, Width - FButtonWidth, 1, Width, Height);
    ExcludeClipRect(DC, R.Left, R.Top, R.Right, R.Bottom);
  end else
  if FEditStyle = esSimple then
  begin
    SetRect(R, 0, 0, Width, Height);
    Windows.MoveToEx(DC, R.Left, R.Top, nil);
    Windows.LineTo(DC, R.Right, R.Top);
  end;
  SelectObject(DC, HOldP);
  DeleteObject(HPbl);
  inherited PaintWindow(DC);
end;

procedure TEnhGridInplaceEdit.SetEditStyle(Value: TEditStyle);
begin
  if Value = FEditStyle then Exit;
  FEditStyle := Value;
  case Value of
    esPickList:
    begin
      if FPickList = nil then
      begin
        FPickList := TPopupListbox.Create(Self);
        with FPickList do
        begin
          Visible := False;
          Parent := Self;
          OnMouseUp := ListMouseUp;
          IntegralHeight := True;
          ItemHeight := 11;
        end;
      end;
      FActiveList := FPickList;
    end;
  else  { lbsNone, lbsEllipsis }
    FActiveList := nil;
  end;
  with TInspectorGrid(Grid) do
    Self.ReadOnly := Lines[Row].ReadOnly;
  Repaint;
end;

procedure TEnhGridInplaceEdit.StopTracking;
begin
  if FTracking then
  begin
    TrackButton(-1, -1);
    FTracking := False;
    MouseCapture := False;
  end;
end;

procedure TEnhGridInplaceEdit.TrackButton(X,Y: Integer);
var
  NewState: Boolean;
  R: TRect;
begin
  SetRect(R, ClientWidth - FButtonWidth, 0, ClientWidth, ClientHeight);
  NewState := PtInRect(R, Point(X, Y));
  if FPressed <> NewState then
  begin
    FPressed := NewState;
    InvalidateRect(Handle, @R, False);
  end;
end;

procedure TEnhGridInplaceEdit.UpdateContents;
var
  Line: TEnhLine;
  NewStyle: TEditStyle;
begin
  with TInspectorGrid(Grid) do
    Line := Lines[Row];
  NewStyle := esSimple;
  case Line.ButtonStyle of
    lbsEllipsis: NewStyle := esEllipsis;
    lbsPicklist: NewStyle := esPickList;
  end;
  EditStyle := NewStyle;
  inherited UpdateContents;
end;

procedure TEnhGridInplaceEdit.CMCancelMode(var Message: TCMCancelMode);
begin
  if (Message.Sender <> Self) and (Message.Sender <> FActiveList) then
    CloseUp(False);
end;

procedure TEnhGridInplaceEdit.WMCancelMode(var Message: TMessage);
begin
  StopTracking;
  inherited;
end;

procedure TEnhGridInplaceEdit.WMKillFocus(var Message: TMessage);
begin
  if SysLocale.FarEast then
  begin
    ImeName := Screen.DefaultIme;
    ImeMode := imDontCare;
  end;
  inherited;
  CloseUp(False);
end;

procedure TEnhGridInplaceEdit.WMLButtonDblClk(var Message: TWMLButtonDblClk);
begin
  with Message do
  if (FEditStyle <> esSimple) and
    PtInRect(Rect(Width - FButtonWidth, 0, Width, Height), Point(XPos, YPos)) then
    Exit;
  inherited;
end;

procedure TEnhGridInplaceEdit.WMPaint(var Message: TWMPaint);
begin
  PaintHandler(Message);
end;

procedure TEnhGridInplaceEdit.WMSetCursor(var Message: TWMSetCursor);
var
  P: TPoint;
begin
  GetCursorPos(P);
  if (FEditStyle <> esSimple) and
    PtInRect(Rect(Width - FButtonWidth, 0, Width, Height), ScreenToClient(P)) then
    Windows.SetCursor(LoadCursor(0, idc_Arrow))
  else
    inherited;
end;

procedure TEnhGridInplaceEdit.WndProc(var Message: TMessage);
begin
  case Message.Msg of
    wm_KeyDown, wm_SysKeyDown, wm_Char:
      if EditStyle in [esPickList, esDataList] then
        with TWMKey(Message) do
        begin
          DoDropDownKeys(CharCode, KeyDataToShiftState(KeyData));
          if (CharCode <> 0) and FListVisible then
          begin
            with TMessage(Message) do
              SendMessage(FActiveList.Handle, Msg, WParam, LParam);
            Exit;
          end;
        end
  end;  // case Message.Msg of
  inherited;
end;


{ TEnhLine }

constructor TEnhLine.Create(Collection: TCollection);
var
  Grid: TInspectorGrid;
begin
  Grid := nil;
  if Assigned(Collection) and (Collection is TEnhGridLines) then
    Grid := TEnhGridLines(Collection).Grid;
  try
    inherited Create(Collection);
    FDropDownRows := 7;
    FButtonStyle := lbsNone;
    FFont := TFont.Create;
    FFont.Assign(DefaultFont);
    FFont.Color := clNavy;
    FFont.OnChange := FontChanged;
    FImeMode := imDontCare;
    FImeName := Screen.DefaultIme;
    FTitle := CreateTitle;
    FData := nil;
  finally
    if Assigned(Grid) then
  end;
end;

destructor TEnhLine.Destroy;
begin
  FTitle.Free;
  FFont.Free;
  FPickList.Free;
  inherited Destroy;
end;

procedure TEnhLine.Assign(Source: TPersistent);
begin
  if Source is TEnhLine then
  begin
    if Assigned(Collection) then Collection.BeginUpdate;
    try
      RestoreDefaults;
      if cvColor in TEnhLine(Source).AssignedValues then
        Color := TEnhLine(Source).Color;
      if cvWidth in TEnhLine(Source).AssignedValues then
        Width := TEnhLine(Source).Width;
      if cvFont in TEnhLine(Source).AssignedValues then
        Font := TEnhLine(Source).Font;
      if cvImeMode in TEnhLine(Source).AssignedValues then
        ImeMode := TEnhLine(Source).ImeMode;
      if cvImeName in TEnhLine(Source).AssignedValues then
        ImeName := TEnhLine(Source).ImeName;
      if cvAlignment in TEnhLine(Source).AssignedValues then
        Alignment := TEnhLine(Source).Alignment;
      if cvReadOnly in TEnhLine(Source).AssignedValues then
        ReadOnly := TEnhLine(Source).ReadOnly;
      Title := TEnhLine(Source).Title;
      DropDownRows := TEnhLine(Source).DropDownRows;
      ButtonStyle := TEnhLine(Source).ButtonStyle;
      PickList := TEnhLine(Source).PickList;
    finally
      if Assigned(Collection) then Collection.EndUpdate;
    end;
  end
  else
    inherited Assign(Source);
end;

function TEnhLine.CreateTitle: TEnhLineTitle;
begin
  Result := TEnhLineTitle.Create(Self);
end;

function TEnhLine.DefaultAlignment: TAlignment;
begin
  Result := taLeftJustify;
end;

function TEnhLine.DefaultColor: TColor;
var
  Grid: TInspectorGrid;
begin
  Grid := GetGrid;
  if Assigned(Grid) then
    Result := Grid.Color
  else
    Result := clWindow;
end;

function TEnhLine.DefaultFont: TFont;
var
  Grid: TInspectorGrid;
begin
  Grid := GetGrid;
  if Assigned(Grid) then
    Result := Grid.Font
  else
    Result := FFont;
end;

function TEnhLine.DefaultImeMode: TImeMode;
var
  Grid: TInspectorGrid;
begin
  Grid := GetGrid;
  if Assigned(Grid) then
    Result := Grid.ImeMode
  else
    Result := FImeMode;
end;

function TEnhLine.DefaultImeName: TImeName;
var
  Grid: TInspectorGrid;
begin
  Grid := GetGrid;
  if Assigned(Grid) then
    Result := Grid.ImeName
  else
    Result := FImeName;
end;

function TEnhLine.DefaultReadOnly: Boolean;
//var
//  Grid: TInspectorGrid;
begin
 // Grid := GetGrid;
  Result := false;
//  Result := (Assigned(Grid) and Grid.ReadOnly);
end;

function TEnhLine.DefaultWidth: Integer;
begin
  if GetGrid = nil then
  begin
    Result := 100;
    Exit;
  end;
  with GetGrid do
    Result := DefaultColWidth;
end;

procedure TEnhLine.FontChanged;
begin
  Include(FAssignedValues, cvFont);
  Title.RefreshDefaultFont;
  Changed(False);
end;

function TEnhLine.GetAlignment: TAlignment;
begin
  if cvAlignment in FAssignedValues then
    Result := FAlignment
  else
    Result := DefaultAlignment;
end;

function TEnhLine.GetColor: TColor;
begin
  if cvColor in FAssignedValues then
    Result := FColor
  else
    Result := DefaultColor;
end;

function TEnhLine.GetFont: TFont;
var
  Save: TNotifyEvent;
begin
  if not (cvFont in FAssignedValues) and (FFont.Handle <> DefaultFont.Handle) then
  begin
    Save := FFont.OnChange;
    FFont.OnChange := nil;
    FFont.Assign(DefaultFont);
    FFont.OnChange := Save;
  end;
  Result := FFont;
end;

function TEnhLine.GetGrid: TInspectorGrid;
begin
  if Assigned(Collection) and (Collection is TEnhGridLines) then
    Result := TEnhGridLines(Collection).Grid
  else
    Result := nil;
end;

procedure TEnhLine.SetData(Value: Pointer);
begin
  FData := Value;
end;

function TEnhLine.GetDisplayName: string;
begin
  Result := inherited GetDisplayName;
end;

function TEnhLine.GetImeMode: TImeMode;
begin
  if cvImeMode in FAssignedValues then
    Result := FImeMode
  else
    Result := DefaultImeMode;
end;

function TEnhLine.GetImeName: TImeName;
begin
  if cvImeName in FAssignedValues then
    Result := FImeName
  else
    Result := DefaultImeName;
end;

function TEnhLine.GetPickList: TStrings;
begin
  if FPickList = nil then
    FPickList := TStringList.Create;
  Result := FPickList;
end;

function TEnhLine.GetReadOnly: Boolean;
begin
  if cvReadOnly in FAssignedValues then
    Result := FReadOnly
  else
    Result := DefaultReadOnly;
end;

function TEnhLine.GetWidth: Integer;
begin
  if cvWidth in FAssignedValues then
    Result := FWidth
  else
    Result := DefaultWidth;
end;

function TEnhLine.IsAlignmentStored: Boolean;
begin
  Result := (cvAlignment in FAssignedValues) and (FAlignment <> DefaultAlignment);
end;

function TEnhLine.IsColorStored: Boolean;
begin
  Result := (cvColor in FAssignedValues) and (FColor <> DefaultColor);
end;

function TEnhLine.IsFontStored: Boolean;
begin
  Result := (cvFont in FAssignedValues);
end;

function TEnhLine.IsImeModeStored: Boolean;
begin
  Result := (cvImeMode in FAssignedValues) and (FImeMode <> DefaultImeMode);
end;

function TEnhLine.IsImeNameStored: Boolean;
begin
  Result := (cvImeName in FAssignedValues) and (FImeName <> DefaultImeName);
end;

function TEnhLine.IsReadOnlyStored: Boolean;
begin
  Result := (cvReadOnly in FAssignedValues) and (FReadOnly <> DefaultReadOnly);
end;

function TEnhLine.IsWidthStored: Boolean;
begin
  Result := (cvWidth in FAssignedValues) and (FWidth <> DefaultWidth);
end;

procedure TEnhLine.RefreshDefaultFont;
var
  Save: TNotifyEvent;
begin
  if cvFont in FAssignedValues then Exit;
  Save := FFont.OnChange;
  FFont.OnChange := nil;
  try
    FFont.Assign(DefaultFont);
  finally
    FFont.OnChange := Save;
  end;
end;

procedure TEnhLine.RestoreDefaults;
var
  FontAssigned: Boolean;
begin
  FontAssigned := cvFont in FAssignedValues;
  FTitle.RestoreDefaults;
  FAssignedValues := [];
  RefreshDefaultFont;
  FPickList.Free;
  FPickList := nil;
  ButtonStyle := lbsNone;
  Changed(FontAssigned);
end;

procedure TEnhLine.SetAlignment(Value: TAlignment);
begin
  if (cvAlignment in FAssignedValues) and (Value = FAlignment) then Exit;
  FAlignment := Value;
  Include(FAssignedValues, cvAlignment);
  Changed(False);
end;

procedure TEnhLine.SetButtonStyle(Value: TEnhLineButtonStyle);
begin
  if Value = FButtonStyle then Exit;
  FButtonStyle := Value;
  Changed(False);
end;

procedure TEnhLine.SetColor(Value: TColor);
begin
  if (cvColor in FAssignedValues) and (Value = FColor) then Exit;
  FColor := Value;
  Include(FAssignedValues, cvColor);
  Changed(False);
end;

procedure TEnhLine.SetFont(Value: TFont);
begin
  FFont.Assign(Value);
  Include(FAssignedValues, cvFont);
  Changed(False);
end;

procedure TEnhLine.SetImeMode(Value: TImeMode);
begin
  if (cvImeMode in FAssignedValues) or (Value <> DefaultImeMode) then
  begin
    FImeMode := Value;
    Include(FAssignedValues, cvImeMode);
  end;
  Changed(False);
end;

procedure TEnhLine.SetImeName(Value: TImeName);
begin
  if (cvImeName in FAssignedValues) or (Value <> DefaultImeName) then
  begin
    FImeName := Value;
    Include(FAssignedValues, cvImeName);
  end;
  Changed(False);
end;

procedure TEnhLine.SetPickList(Value: TStrings);
begin
  if Value = nil then
  begin
    FPickList.Free;
    FPickList := nil;
    Exit;
  end;
  PickList.Assign(Value);
end;

procedure TEnhLine.SetReadOnly(Value: Boolean);
begin
  if (cvReadOnly in FAssignedValues) and (Value = FReadOnly) then Exit;
  FReadOnly := Value;
  Include(FAssignedValues, cvReadOnly);
  if Value then
    FFont.Color := clBtnShadow;
  Changed(False);
end;

procedure TEnhLine.SetTitle(Value: TEnhLineTitle);
begin
  FTitle.Assign(Value);
end;

procedure TEnhLine.SetWidth(Value: Integer);
begin
  if (cvWidth in FAssignedValues) or (Value <> DefaultWidth) then
  begin
    FWidth := Value;
    Include(FAssignedValues, cvWidth);
  end;
  Changed(False);
end;

{ TEnhGridLines }

constructor TEnhGridLines.Create(Grid: TInspectorGrid; LineClass: TEnhLineClass);
begin
  inherited Create(LineClass);
  FGrid := Grid;
end;

function TEnhGridLines.Add: TEnhLine;
begin
  Result := TEnhLine(inherited Add);
end;

function TEnhGridLines.GeTEnhLine(Index: Integer): TEnhLine;
begin
  Result := TEnhLine(inherited Items[Index]);
end;

function TEnhGridLines.GetCount: Integer;
begin
  Result := inherited Count;
end;

function TEnhGridLines.GetOwner: TPersistent;
begin
  Result := FGrid;
end;

function TEnhGridLines.GetState: TEnhGridLinesState;
begin
  Result := TEnhGridLinesState((Count > 0)) ;
end;

procedure TEnhGridLines.LoadFromFile(const Filename: string);
var
  S: TFileStream;
begin
  S := TFileStream.Create(Filename, fmOpenRead);
  try
    LoadFromStream(S);
  finally
    S.Free;
  end;
end;

type
  TEnhLinesWrapper = class(TComponent)
  private
    FLines: TEnhGridLines;
  published
    property Lines: TEnhGridLines read FLines write FLines;
  end;

procedure TEnhGridLines.LoadFromStream(S: TStream);
{var
  Wrapper: TEnhLinesWrapper;}
begin
 { Wrapper := TEnhLinesWrapper.Create(nil);
  try
    Wrapper.Lines := FGrid.CreateLines;
    S.ReadComponent(Wrapper);
    Assign(Wrapper.Lines);
  finally
    Wrapper.Lines.Free;
    Wrapper.Free;
  end;}
end;

procedure TEnhGridLines.RestoreDefaults;
var
  I: Integer;
begin
  BeginUpdate;
  try
    for I := 0 to Count-1 do
      Items[I].RestoreDefaults;
  finally
    EndUpdate;
  end;
end;

procedure TEnhGridLines.RebuildLines;
begin
end;

procedure TEnhGridLines.SaveToFile(const Filename: string);
var
  S: TStream;
begin
  S := TFileStream.Create(Filename, fmCreate);
  try
    SaveToStream(S);
  finally
    S.Free;
  end;
end;

procedure TEnhGridLines.SaveToStream(S: TStream);
var
  Wrapper: TEnhLinesWrapper;
begin
  Wrapper := TEnhLinesWrapper.Create(nil);
  try
    Wrapper.Lines := Self;
    S.WriteComponent(Wrapper);
  finally
    Wrapper.Free;
  end;
end;

procedure TEnhGridLines.SeTEnhLine(Index: Integer; Value: TEnhLine);
begin
  Items[Index].Assign(Value);
end;

procedure TEnhGridLines.SetState(NewState: TEnhGridLinesState);
begin
  if NewState = State then Exit;
  if NewState = csDefault then
    Clear
  else
    RebuildLines;
end;

procedure TEnhGridLines.Update(Item: TCollectionItem);
begin
end;

{TGridSplit}

constructor TGridSplit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FMinSize := 50;
  Width := 2;
  Left:= 1;
  FControl := AOwner as TControl;
  Height := (AOwner as TInspectorGrid).Height;  
  BevelOuter:= bvNone;
  BevelInner:= bvLowered;
  Cursor:= crHSplit;
  Color:= clBtnFace;
  ControlStyle := ControlStyle - [csAcceptsControls, csSetCaption];
end;

destructor TGridSplit.Destroy;
begin
  inherited Destroy;
end;

procedure TGridSplit.AllocateLineDC;
begin
  FLineDC := GetDCEx(Parent.Handle, 0,
                     DCX_CACHE or DCX_CLIPSIBLINGS or DCX_LOCKWINDOWUPDATE);
end;

procedure TGridSplit.DrawLine;
var
  P: TPoint;
begin
  FLineVisible := not FLineVisible;
  P := Point(Left, Top);
  P.X := Left + FSplit;
  with P do PatBlt(FLineDC, X, Y, Width, Height, PATINVERT);
end;

procedure TGridSplit.ReleaseLineDC;
begin
  ReleaseDC(Parent.Handle, FLineDC);
end;

procedure TGridSplit.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited;
  if Button = mbLeft then
  begin
    FControl := Owner as TControl;
    FDownPos := Point(X, Y);
    if Assigned(FControl) then
    begin
      FMaxSize := FControl.ClientWidth - FMinSize;
      UpdateSize(X, Y);
      AllocateLineDC;
      with ValidParentForm(Self) do
        if ActiveControl <> nil then
          FActiveControl := ActiveControl;
      DrawLine;
    end;
  end;
end;

procedure TGridSplit.UpdateSize(X, Y: Integer);
var
  S: Integer;
begin
  FSplit := X - FDownPos.X;
  S := Left + FSplit;
  FNewSize := S;
  if S < FMinSize then
    FNewSize := FMinSize
  else if S > FMaxSize then
    FNewSize := FMaxSize;
  if S <> FNewSize then
  begin
    S := FNewSize - S;
    Inc(FSplit, S);
  end;
end;

procedure TGridSplit.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if Assigned(FControl) then
  begin
    DrawLine;
    UpdateSize(X, Y);
    DrawLine;
  end;
end;

procedure TGridSplit.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited;
  if Assigned(FControl) then
  begin
    DrawLine;
    Left := Left + FSplit;
    (Owner as TInspectorGrid).ResizeColums;
    StopSizing;
  end;
end;

procedure TGridSplit.StopSizing;
begin
  if Assigned(FControl) then
  begin
    if FLineVisible then DrawLine;
    FControl := nil;
    ReleaseLineDC;
  end;
  if Assigned(FOnMoved) then
    FOnMoved(Self, Left - FSplit, Left);
end;

{ TInspectorGrid }

constructor TInspectorGrid.Create(Owner: TComponent);
begin
  inherited Create(Owner);
  inherited ColCount := 2;
  inherited FixedCols := 1;
  inherited FixedRows := 0;
  inherited RowCount := 1;

  Lines := TEnhGridLines.Create(Self, TEnhLine);
  Lines.Add;

  DefaultRowHeight := 18;
  DefaultColWidth := 90;
  Height := 98;
  Width := 222;
  Color := clBtnFace;
  DesignOptionsBoost := [];
  FOptions := [egoHorzLine, egoEditing, egoAlwaysShowEditor];
  inherited Options := inherited Options - [goFixedVertLine,goFixedHorzLine, goRangeSelect, goRowSizing, goRowMoving, goColMoving, goRowSelect];
  inherited Options := inherited Options + [goEditing, goAlwaysShowEditor, goColSizing, goVertLine];
  ScrollBars:= ssVertical;
  FSelectedTitleBold := true;

  GridSplit1 := TGridSplit.Create(Self);

  GridSplit1.Parent := Self;
  with GridSplit1 do
  begin
    if not Assigned(GridSplit1) then exit;
    Left:= DefaultColWidth; // Fin de la 1ere colonne fixe
    Top:= 0;
    Width:= 2;
    Height:= 94;
    Cursor:= crHSplit;
    BevelInner:= bvLowered;
    BevelOuter:= bvNone;
  end;
  HideEditor;
end;

destructor TInspectorGrid.Destroy;
begin
  inherited Destroy;
end;

procedure TInspectorGrid.SetOnSplitMoved(value: TMovedSplitEvent);
begin
  GridSplit1.OnMoved:= Value;
end;

function TInspectorGrid.GetOnSplitMoved: TMovedSplitEvent;
begin
  GetOnSplitMoved:= GridSplit1.OnMoved;
end;

// procedure  chier... A refaire!
procedure TInspectorGrid.SetOptions(value: TEnhGridOptions);
begin
  if FOptions <> Value then
  begin
    if egoFixedVertLine in Value then
      inherited Options := inherited Options + [goFixedVertLine]
    else
      inherited Options := inherited Options - [goFixedVertLine];
    if egoFixedHorzLine in Value then
      inherited Options := inherited Options + [goFixedHorzLine]
    else
      inherited Options := inherited Options - [goFixedHorzLine];
    if egoHorzLine in Value then
      inherited Options := inherited Options + [goHorzLine]
    else
      inherited Options := inherited Options - [goHorzLine];
    if egoDrawFocusSelected in Value then
      inherited Options := inherited Options + [goDrawFocusSelected]
    else
      inherited Options := inherited Options - [goDrawFocusSelected];
    if egoEditing in Value then
      inherited Options := inherited Options + [goEditing]
    else
      inherited Options := inherited Options - [goEditing];
    if egoTabs in Value then
      inherited Options := inherited Options + [goTabs]
    else
      inherited Options := inherited Options - [goTabs];
    if egoAlwaysShowEditor in Value then
      inherited Options := inherited Options + [goAlwaysShowEditor]
    else
      inherited Options := inherited Options - [goAlwaysShowEditor];
    if egoThumbTracking in Value then
      inherited Options := inherited Options + [goThumbTracking]
    else
      inherited Options := inherited Options - [goThumbTracking];
    FOptions := Value;
    if not (egoEditing in Value) then
      Exclude(FOptions, egoAlwaysShowEditor);
      if egoAlwaysShowEditor in Value then
        ShowEditor
      else
        HideEditor;
    Invalidate;
  end;
end;

procedure TInspectorGrid.SetSelectedTitleBold(Value: boolean);
begin
  if FSelectedTitleBold <> Value then
  begin
    FSelectedTitleBold := Value;
    invalidate;
  end;
end;

procedure TInspectorGrid.ResizeColums;
begin
  if ClientWidth - GridSplit1.Left < 50 then
    GridSplit1.Left:= ClientWidth - 50;
  if GridSplit1.Left < 50 then GridSplit1.Left:= 50;
  if (ColCount > 0) then
  begin
    ColWidths[0]:= GridSplit1.Left;
    ColWidths[LeftCol]:= ClientWidth - ColWidths[0];
  end;
  GridSplit1.Height:= GridHeight;
end;

procedure TInspectorGrid.WMSize(var Msg: TWMSize);
begin
  inherited;
  if (ColCount > 1) then
    UpdateEditCellsSize;
  if Assigned(GridSplit1) then
    GridSplit1.Height := GridHeight;
end;

procedure TInspectorGrid.UpdateEditCellsSize;
var
  delta: integer;
begin
  if (GridHeight < Height) then
    delta := 0
  else
    delta := 22;
  ColWidths[LeftCol] := (Width - (ColWidths[0] + delta));
  if GridSplit1 <> nil then
    GridSplit1.Left := ColWidths[0];
end;

procedure TInspectorGrid.Editbuttonclick;
begin
  if assigned(OnElippsisclicked) then
    OnElippsisclicked(Self, Col, Row)
end;

function TInspectorGrid.GetColCount: Integer;
begin
  result := inherited ColCount
end;

function TInspectorGrid.GetRowCount: Integer;
begin
  result := inherited RowCount
end;

procedure TInspectorGrid.SetRowCount(ARow: LongInt);
var
  oldrow: Longint;
  TR: TRect;
  i: integer;
begin
  oldrow := inherited Rowcount;
  if oldrow <> ARow then
  begin
    if ARow > oldrow then
    begin
      while oldrow < ARow do begin
        Lines.add;
        inc(oldrow);
        if assigned(FOnNewRow) then
          FOnNewRow(self);
      end;
    end else
    begin
      while oldrow > ARow do
      begin
        for i := Rows[Lines.count -1].Count - 1 downto 0 do
          if Assigned(Rows[Lines.count -1].Objects[i]) then
            Rows[Lines.count -1].Objects[i].Free;
        Rows[Lines.count -1].Clear;
        Lines.items[Lines.count -1].free;
        dec(oldrow);
      end;
    end;
  end;
  inherited Rowcount := ARow;
  if ARow = 0 then  // CustomGrid laisse toujours 1 ligne minimum
  begin
    Lines.add;
    TR := ClientRect;
    TR.Top := TR.Top + DefaultRowHeight + 1;
    GridSplit1.Height := DefaultRowHeight + 1;
    ValidateRect(Self.Handle, @TR);
    Update;
    UpdateEditCellsSize;
    HideEditor;
  end;
  if Assigned(GridSplit1) then
    GridSplit1.Height := GridHeight;
end;

function TInspectorGrid.GetDefaultColWidth: integer;
begin
  GetDefaultColWidth := inherited DefaultColWidth;
end;

procedure TInspectorGrid.SetDefaultColWidth(Value: integer);
begin
  if DefaultColWidth <> Value then
  begin
    inherited DefaultColWidth := Value;
    if Assigned(GridSplit1) then
      UpdateEditCellsSize;
  end;
end;

function TInspectorGrid.CreateEditor: TInplaceEdit;
begin
  Result := TEnhGridInplaceEdit.Create(Self);
end;

procedure TInspectorGrid.HideEditor;
begin
  inherited HideEditor;
end;

procedure TInspectorGrid.ShowEditor;
begin
  inherited ShowEditor;
end;

procedure TInspectorGrid.KeyDown(var Key: Word; Shift: TShiftState);
var
  oldRow: integer;
  oldTR, TR: TRect;
begin
  oldRow := Row;
  oldTR := CellRect(0, oldRow);
  inherited KeyDown(Key, Shift);
  if ( ((Key = Vk_Up) or (Key = VK_PRIOR)) and ((Row >= 0) or (oldRow = 1)) ) or
     ( ((Key = Vk_Down) or (Key = Vk_Next)) and ((Row <= RowCount-1) or (oldRow = RowCount-2)) ) then
  begin
    if oldRow <> Row then
      InvalidateRow(oldRow);
    Update;
    TR := CellRect(0, Row);
    DrawCell(0, Row, TR, [gdFixed]);
  end;
end;

procedure TInspectorGrid.DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState);

  function RowIsMultiSelected: Boolean;
  begin
    Result :=false;
  end;

var
  DrawLine: TEnhLine;
  FrameOffs: Byte;
begin
  if csLoading in ComponentState then
  begin
    Canvas.Brush.Color := Color;
    Canvas.FillRect(ARect);
    Exit;
  end;

  if (gdFixed in AState) then
  begin
    InflateRect(ARect, -1, -1);
    FrameOffs := 3;
  end
  else
    FrameOffs := 2;

  with Canvas do
  begin
    DrawLine := Lines[ARow];
    if gdFixed in AState then
    begin
      Font := DrawLine.Title.Font;
      Brush.Color := DrawLine.Title.Color;
      Pen.Color := clGray;
      Pen.Style := psSolid;
    end
    else
    begin
      Font := DrawLine.Font;
      Brush.Color := DrawLine.Color;
      Pen.Color := clBlack;
      Pen.Width := 1;
    end;
    with DrawLine do
      WriteText(Canvas, ARect, FrameOffs, FrameOffs, cells[Acol, Arow], Alignment);

    if (gdFixed in AState) then
    begin
      if (ARow <> Row) or (not IsActiveControl) then
      begin
        InflateRect(ARect, 2, 2);
        if ACol < 1 then
          with DrawLine.Title do
            WriteText(Canvas, ARect, FrameOffs, FrameOffs, Caption, Alignment);
        MoveTo(ARect.Left, ARect.Top);
        LineTo(ARect.Right-1, ARect.Top);
        LineTo(ARect.Right-1, ARect.Bottom-1);
        LineTo(ARect.Left, ARect.Bottom-1);
        LineTo(ARect.Left, ARect.Top);
      end else
      begin     // Ligne slectionne
        if not (csDesigning in ComponentState) then
        begin
          InflateRect(ARect, 2, 2);
          if ACol < 1 then
          begin
            if FSelectedTitleBold then  // Style du titre slectionn
              Font.Style := [fsBold]
            else
              Font.Style := [];

            with DrawLine.Title do
              WriteText(Canvas, ARect, FrameOffs, FrameOffs, Caption, Alignment);
          end;
          if Lines.Items[ARow].Title.Caption <> '' then
          begin
            Pen.Color := clBlack;
            MoveTo(ARect.Left+1, ARect.Bottom-1);
            LineTo(ARect.Left+1, ARect.Top+1);
            LineTo(ARect.Right, ARect.Top+1);
          end;

          Pen.Color := clGray;
          MoveTo(ARect.Left, ARect.Top);
          LineTo(ARect.Right, ARect.Top);

          MoveTo(ARect.Right-1, ARect.Top+1);
          LineTo(ARect.Right-1, ARect.Bottom-1);

          MoveTo(ARect.Right-1, ARect.Bottom-1);
          LineTo(ARect.Left, ARect.Bottom-1);
        end;
      end;  // if not (csDesigning in ComponentState)
    end;  // if ARow <> Row else
  end;  // With Canvas do
end;

procedure TInspectorGrid.Paint;
begin
  inherited Paint;
end;

type
  PIntArray = ^TIntArray;
  TIntArray = array[0..MaxCustomExtents] of Integer;

procedure TInspectorGrid.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  CellHit: TGridCoord;
  oldRow: integer;
  oldTR, TR: TRect;
begin
  if not (csDesigning in ComponentState) and
    (CanFocus or (GetParentForm(Self) = nil)) then
  begin
    SetFocus;
    if not IsActiveControl then
    begin
      MouseCapture := False;
      Exit;
    end;
  end;
  if Button = mbLeft then
  begin
    MouseToCell(X, Y, CellHit.X, CellHit.Y);
    if (CellHit.X <= FixedCols) and (CellHit.Y <= RowCount) and
       ((CellHit.X > -1) and (CellHit.Y > -1)) then
    begin

      oldRow := Row;
      oldTR := CellRect(0, oldRow);
      Row := CellHit.Y;   // Dplacement sur nouvelle ligne
      if oldRow <> CellHit.Y then
      begin
        InvalidateRow(oldRow);
        Update;
      end;

      TR := CellRect(0, Row);
      DrawCell(0, Row, TR, [gdFixed]);

      if (egoEditing in FOptions) and not EditorMode then
        ShowEditor;   // Si RAZ de la grille, l'diteur est cach
    end;
  end;
  inherited MouseDown(Button, Shift, X, Y);
end;

function TInspectorGrid.IsActiveControl: Boolean;
var
  H: Hwnd;
  ParentForm: TCustomForm;
begin
  Result := False;
  ParentForm := GetParentForm(Self);
  if Assigned(ParentForm) then
  begin
    if (ParentForm.ActiveControl = Self) then
      Result := True
  end
  else
  begin
    H := GetFocus;
    while IsWindow(H) and (Result = False) do
    begin
      if H = WindowHandle then
        Result := True
      else
        H := GetParent(H);
    end;
  end;
end;

procedure TInspectorGrid.WMVScroll(var Msg: TWMVScroll);
begin
  inherited;
  if Assigned(GridSplit1) then
    GridSplit1.Invalidate;
end;

procedure TInspectorGrid.Clear;
begin
  RowCount := 0;
end;

end.
